# coding: utf-8

# flake8: noqa

"""
    Bare Metal Cloud API

    Create, power off, power on, reset, reboot, or shut down your server with the Bare Metal Cloud API.  Deprovision servers, get or edit SSH key details, assign public IPs, assign servers to networks and a lot more.  Manage your infrastructure more efficiently using just a few simple API calls.<br> <br> <span class='pnap-api-knowledge-base-link'> Knowledge base articles to help you can be found <a href='https://phoenixnap.com/kb/how-to-deploy-bare-metal-cloud-server' target='_blank'>here</a> </span><br> <br> <b>All URLs are relative to (https://api.phoenixnap.com/bmc/v1/)</b> 

    The version of the OpenAPI document: 0.1
    Contact: support@phoenixnap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "2.2.1"

# import apis into sdk package
from pnap_bmc_api.api.quotas_api import QuotasApi
from pnap_bmc_api.api.ssh_keys_api import SSHKeysApi
from pnap_bmc_api.api.servers_api import ServersApi

# import ApiClient
from pnap_bmc_api.api_response import ApiResponse
from pnap_bmc_api.api_client import ApiClient
from pnap_bmc_api.configuration import Configuration
from pnap_bmc_api.exceptions import OpenApiException
from pnap_bmc_api.exceptions import ApiTypeError
from pnap_bmc_api.exceptions import ApiValueError
from pnap_bmc_api.exceptions import ApiKeyError
from pnap_bmc_api.exceptions import ApiAttributeError
from pnap_bmc_api.exceptions import ApiException

# import models into sdk package
from pnap_bmc_api.models.action_result import ActionResult
from pnap_bmc_api.models.delete_result import DeleteResult
from pnap_bmc_api.models.delete_ssh_key_result import DeleteSshKeyResult
from pnap_bmc_api.models.error import Error
from pnap_bmc_api.models.esxi_datastore_configuration import EsxiDatastoreConfiguration
from pnap_bmc_api.models.esxi_os_configuration import EsxiOsConfiguration
from pnap_bmc_api.models.gpu_configuration import GpuConfiguration
from pnap_bmc_api.models.ip_blocks_configuration import IpBlocksConfiguration
from pnap_bmc_api.models.network_configuration import NetworkConfiguration
from pnap_bmc_api.models.os_configuration import OsConfiguration
from pnap_bmc_api.models.os_configuration_cloud_init import OsConfigurationCloudInit
from pnap_bmc_api.models.os_configuration_map import OsConfigurationMap
from pnap_bmc_api.models.os_configuration_map_esxi import OsConfigurationMapEsxi
from pnap_bmc_api.models.os_configuration_map_proxmox import OsConfigurationMapProxmox
from pnap_bmc_api.models.os_configuration_netris_controller import OsConfigurationNetrisController
from pnap_bmc_api.models.os_configuration_netris_softgate import OsConfigurationNetrisSoftgate
from pnap_bmc_api.models.os_configuration_windows import OsConfigurationWindows
from pnap_bmc_api.models.private_network_configuration import PrivateNetworkConfiguration
from pnap_bmc_api.models.public_network_configuration import PublicNetworkConfiguration
from pnap_bmc_api.models.quota import Quota
from pnap_bmc_api.models.quota_edit_limit_request import QuotaEditLimitRequest
from pnap_bmc_api.models.quota_edit_limit_request_details import QuotaEditLimitRequestDetails
from pnap_bmc_api.models.relinquish_ip_block import RelinquishIpBlock
from pnap_bmc_api.models.reset_result import ResetResult
from pnap_bmc_api.models.server import Server
from pnap_bmc_api.models.server_create import ServerCreate
from pnap_bmc_api.models.server_ip_block import ServerIpBlock
from pnap_bmc_api.models.server_network_update import ServerNetworkUpdate
from pnap_bmc_api.models.server_patch import ServerPatch
from pnap_bmc_api.models.server_private_network import ServerPrivateNetwork
from pnap_bmc_api.models.server_provision import ServerProvision
from pnap_bmc_api.models.server_public_network import ServerPublicNetwork
from pnap_bmc_api.models.server_reserve import ServerReserve
from pnap_bmc_api.models.server_reset import ServerReset
from pnap_bmc_api.models.ssh_key import SshKey
from pnap_bmc_api.models.ssh_key_create import SshKeyCreate
from pnap_bmc_api.models.ssh_key_update import SshKeyUpdate
from pnap_bmc_api.models.storage_configuration import StorageConfiguration
from pnap_bmc_api.models.storage_configuration_root_partition import StorageConfigurationRootPartition
from pnap_bmc_api.models.tag_assignment import TagAssignment
from pnap_bmc_api.models.tag_assignment_request import TagAssignmentRequest
